-- Useful hex functions

function drawhex(x, y, w, h, r, g, b, a, f, fr, fg, fb, fa)
  w, h = w or 120, h or 140
  r, g, b, a = r or 255, g or 255, b or 255, a or 255
  f = f or "No"
  fr, fg, fb, fa = fr or r, fg or g, fb or b, fa or a
  local thickness = math.ceil(math.min(w, h)/40)
  local i
  if f == "Yes" then
    love.graphics.setColor(fr, fg, fb, fa)
    love.graphics.rectangle("fill", x-(w/2), y-(h/4), w, h/2)
    love.graphics.polygon("fill", x-(w/2), y-(h/4), x, y-(h/2), x+(w/2), y-(h/4))
    love.graphics.polygon("fill", x-(w/2), y+(h/4), x, y+(h/2), x+(w/2), y+(h/4))
  end
  if thickness >= 0 then
    love.graphics.setColor(r, g, b, a)
    for i = 0, thickness, 1 do
      love.graphics.line(x+i-(w/2), y-(h/4), x, y+i-(h/2), x-i+(w/2), y-(h/4), x-i+(w/2), y+(h/4), x, y-i+(h/2), x+i-(w/2), y+(h/4), x+i-(w/2), y-(h/4))
    end
  end
end

function getflatcoord(x, y, z)
  local a = x + (z + (z%2)) / 2
  local b = z
  return a, b
end

function getcubecoord(x, y)
  local a = x - (y + (y%2)) / 2
  local c = y
  local b = -a-c
  return a, b, c
end

function getcubedist(a, b, c, x, y, z)
  return math.max(math.abs(a-x), math.abs(b-y), math.abs(c-z))
end

function getflatdist(x1, y1, x2, y2)
  local a, b, c = getcubecoord(x1, y1)
  local x, y, z = getcubecoord(x2, y2)
  return getcubedist(a, b, c, x, y, z)
end

function getwithinhex(x, y, cx, cy, w, h)
  if x>cx-(w/2) and x<cx+(w/2) and y>cy-(h/4) and y<cy+(h/4) then return true
  elseif x>=cx and y>=cy+(h/4) and x-cx<2*(cy+(h/2)-y) then return true
  elseif x>=cx and y<=cy-(h/4) and x-cx<2*(y+(h/2)-cy) then return true
  elseif x<cx and y>=cy+(h/4) and cx-x<2*(cy+(h/2)-y) then return true
  elseif x<cx and y<=cy-(h/4) and cx-x<2*(y+(h/2)-cy) then return true
  else return false end
end